<?php 
/*
Klasse omysql                                
Klasse mit verschiedenen mysql Datenbankfunktionen.

Eigenschaften: 
anzahl                        Anzahl gefundener oder modifizierten Datensaetzen
fehler                        Fehlerausgabe
erg                           array mit dem Ergebnis eines Queries
Methoden:      
query($sql)                   Abfrage Datenbank. Ergebnis wird in Eigenschaft erg als Array gespeichert.    
felder($tabelle)              Gibt die Tabellendefinition in Eigenschaft erg als Array zurÃ¼ck. 
tablecomment($tabelle)        Gibt den Tabellenkommentar zurÃ¼ck.
tabellen()                    Gibt ein Array mit allen Tabellen der aktuellen Datenbank zurÃ¼ck.
dump($datei,$tabelle,$drop)   Erzeugt eine Datei mit einem Dump einer Tabelle, oder aller Tabellen 
                              der aktuellen DB. drop = true; lÃ¶scht die Tabelle(n) zuvor.
                              $tabelle = "" selektiert alle Tabellen. 
---------------------------------------------------------------------------------------------------------
*/
class omysql
{	
	public $anzahl;
	public $fehler;
	public $erg;
	private $odb;
	private $dbname;
	public function __construct() {
	    $db_server = 'localhost';  // Tragen Sie hier Ihren Datenbangserver ein
		$db_name = 'Ihre_datenbank'; // Tragen Sie hier den Namen Ihrer Datenbank ein
		$db_user = 'datenbankuser';  // Tragen Sie hier Ihren Benutzernamen der Datenbank ein
		$db_passwort = 'Ihr_passwort'; // Tragen Sie hier Ihr Passwort Ihrer Datenbank ein
		include('../mysql.php');
		$db = @ mysql_connect ( $db_server, $db_user, $db_passwort )
			or die ( 'Konnte keine Verbindung zur Datenbank herstellen' );
		$this->odb = $db;
		$this->dbname = $db_name;
		$db_check = @ mysql_select_db ( $db_name );
		$db_select = @ mysql_select_db( $db_name );
	}
	public function query($sql) {
	unset($this->erg);
	//$sql = mysql_real_escape_string($sql);
	$result = mysql_query ( $sql );
	if ($result) {
	 if (preg_match("/\bselect\b/i",$sql)) {
      $this->anzahl = mysql_num_rows ( $result );
      while($row = mysql_fetch_array( $result )) 
		$this->erg[] = $row;
      return $result;
     } 
     elseif (preg_match("/\bupdate\b|\binsert\b|\bdelete\b/i",$sql)) {
      $this->anzahl = mysql_affected_rows ();
      return $result;
     }
     elseif (preg_match("/\bdrop\b|\bcreate\b/i",$sql)) {
      $this->anzahl = mysql_affected_rows ();
      return $result;
     }
    }
    else {
    $this->fehler = "Fehler: (" .mysql_errno() . ") " .mysql_error();
     return false;
    }
	}
	public function tablecomment($tabelle) {
	 $res = mysql_query("SHOW TABLE STATUS LIKE '$tabelle'");
	 if ($res) {
	 	while ($cells = mysql_fetch_array($res)) {
		 $row = $cells;	     
	    }
	    if (!empty($row['Comment']))
	     return $row['Comment'];
	    else
	     return false;
	 }
	 else
	  return false;
	}
	public function felder($tabelle) {
	 unset($this->erg);
	 $tabelle = mysql_real_escape_string($tabelle);
     $result = mysql_query ("SHOW FULL COLUMNS FROM $tabelle");
     if ($result) {
      while ($data = mysql_fetch_array($result))
       {    
         $afelder[] = $data;    
       }
       $this->erg=$afelder;
	   return true;  
	 }
	 else {
	  $this->fehler = "Fehler: Tabelle '$tabelle' existiert nicht!";
	  return false;
	 }
	} 
	public function tabellen() {
	 $res = mysql_query("SHOW TABLES");
	 if ($res) {
	 	while ($cells = mysql_fetch_array($res)) {
		 $tables[] = $cells[0];	     
	    }
	    return $tables;
	 }
	 else
	  return false;
	}
	public function dump($datei,$tabelle = "",$drop = false) {
	    include('mysql.php');
		$f = fopen($datei, "w");
		//$tables = mysql_list_tables($db_name);
		if (empty($tabelle))
		 $tables = mysql_query("SHOW TABLES");
		else
		 $tables = mysql_query("SHOW TABLES like '$tabelle'");		 
		fwrite($f,"--\n"); 
		fwrite($f,"SET SQL_MODE='NO_AUTO_VALUE_ON_ZERO';\n"); 
		fwrite($f,"--\n"); 
		while ($cells = mysql_fetch_array($tables)) {
		 $table = $cells[0];
		 if ($drop)
		  fwrite($f,"DROP TABLE IF EXISTS `$table`;\n"); 
		 $res = mysql_query("SHOW CREATE TABLE `$table`");
		 if ($res) {
		  $create = mysql_fetch_array($res);
		  $create[1] .= ";";
		  $line = str_replace("\n", "", $create[1]);
		  fwrite($f, $line."\n");
		  $data = mysql_query("SELECT * FROM `$table`");
		  $num = mysql_num_fields($data);
		  while ($row = mysql_fetch_array($data)){
		   $line = "INSERT INTO `$table` VALUES(";
		   for ($i=1;$i<=$num;$i++) {
		    $line .= "'".mysql_real_escape_string($row[$i-1])."', ";
		   }
		   $line = substr($line,0,-2);
		   fwrite($f, $line.");\n");
		  }
		 }
		}
		fclose($f);
	}
	public function __destruct() {	 
		$db_close = @ mysql_close ( $this->odb );
	}
}  // Ende class omysql
?>